#include "MyMainWindow.h"

void MyMainWindow::botonazo(){
	std::cout << "apachurraste un boton, ero" << std::endl;
}
void MyMainWindow::add_view(QWidget * viewthis, SoGroup * common, SbRotation cameraorientation){

	SoSeparator * root = new SoSeparator;

	SoPerspectiveCamera * camera = new SoPerspectiveCamera;
	camera->orientation = cameraorientation;
	root->addChild(camera);

	root->addChild(common);
		
	SoQtExaminerViewer * area = new SoQtExaminerViewer(viewthis);
      
	//SoQtRenderArea * area = new SoQtRenderArea(viewthis);
	area->setSceneGraph(root);

	#ifndef __COIN__
	// IMPORTANT: make sure each GL context has a unique cache context
	// id.  this is needed for TGS/SGI Inventor. Coin handles this
	// automatically.
	static uint32_t contextcnt = 0;
	area->getGLRenderAction()->setCacheContext(contextcnt++);
	#endif // !__COIN__

	camera->viewAll(root, area->getViewportRegion());
}

MyMainWindow::MyMainWindow(void){

	//	QWidget * this = new QWidget;
  
	this->setMinimumSize(300, 200);


	// Set up the Qt widget layout data.

	QHBoxLayout * hlayout = new QHBoxLayout(this);

	QGroupBox * view0 = new QGroupBox(this);
	hlayout->addWidget(view0, 0.66);

	QVBoxLayout * vlayout = new QVBoxLayout();
	hlayout->addLayout(vlayout, 0.33);

	QGroupBox * view1 = new QGroupBox(this);
	vlayout->addWidget(view1, 0.50);
	QGroupBox * view2 = new QGroupBox(this);
	vlayout->addWidget(view2, 0.50);

	QSpinBox *spinBox = new QSpinBox;
	QSlider *slider = new QSlider(Qt::Horizontal);
	spinBox->setRange(0, 130);
	slider->setRange(0, 130);
	vlayout->addWidget(spinBox, 0.50);
	
	
	boton1 = new QPushButton("boton 1");  
	connect(this->boton1, SIGNAL(clicked()),this, SLOT(botonazo()));
	vlayout->addWidget(boton1, 0.50);
	QPushButton *boton2 = new QPushButton("boton 2");
	vlayout->addWidget(boton2, 0.50);
	QPushButton *boton3 = new QPushButton("boton 3");
	vlayout->addWidget(boton3, 0.50);
	QPushButton *boton4 = new QPushButton("boton 4");
	vlayout->addWidget(boton4, 0.50);
	// Construct the common part of the scenegraph.

	SoGroup * commonroot = new SoGroup;
	SoDirectionalLight * light = new SoDirectionalLight;
	light->direction.setValue(-0.5, -0.5, -0.8);
	commonroot->addChild(light);
	SoRotation * scenerotate = new SoRotation;
	commonroot->addChild(scenerotate);

    /****************************************************************************************/
    //aca va simage creo
    
	 SoTexture2 * textura1;
	 textura1 = new SoTexture2();
	 textura1->filename.setValue("baboon.png"); 
	 commonroot->addChild(textura1);
        
    //***************************************************************************************/

    SoCube * cube = new SoCube;
    commonroot->addChild(cube);
    /****************************************************************************************/
    //aca va simage creo
    
	 SoTexture2 * textura2;
	 textura2 = new SoTexture2();
	 textura2->filename.setValue("pelo.PNG"); 
	 commonroot->addChild(textura2);
        
    //***************************************************************************************/

    SoTranslation * trans = new SoTranslation;
    trans->translation.setValue(0, 0, 1);
    commonroot->addChild(trans);

    SoSphere * sphere = new SoSphere;
    sphere->radius = 0.5;
    commonroot->addChild(sphere);

	// Add the 3 renderareas.

	add_view(view0, commonroot, SbRotation(SbVec3f(0, 0, 1), 0));
	add_view(view1, commonroot, SbRotation(SbVec3f(0, 1, 0), M_PI / 2.0f));
	add_view(view2, commonroot, SbRotation(SbVec3f(1, 0, 0), -M_PI / 2.0f));

 }